SDFAPI(1)

NAME
sdfapi - API Extraction Utility

PURPOSE
sdfapi extracts Application Programming Interface information from (Perl) source code.

USAGE
 usage  : sdfapi [-h[help]] [-o[out_ext]]
         [-l[log_ext]] [-O[out_dir]] [-f fmt_tag]
         [-p[pattern]] [-s sym_type,..] [-j]
         file ...
purpose: extract the API from a (perl) library
version: 2.000    (SDF 2.001)

The options are:

 Option       Description
 -h           display help on options
 -o           output file extension
 -l           log file extension
 -O           output to input file's (or explicit) directory
 -f           output format tag
 -p           only symbols matching pattern
 -s           only symbols of these types
 -j           add SDF-style hypertext jumps from each symbol

DESCRIPTION
The -h option provides help. If it is specified without a parameter, a brief description of each option is displayed. To display the attributes for an option, specify the option letter as a parameter.

By default, generated output goes to standard output. To direct output to a file per input file, use the -o option to specify an extension for output files. If the -o option is specified without a parameter, an extension of out is assumed.

Likewise, error messages go to standard error by default. Use the -l option to create a log file per input file. If the -l option is specified without a parameter, an extension of log is assumed.

By default, generated output and log files are created in the current directory. Use the -O option to specify an explicit output directory. If the -O option is specified without a parameter, the input file's directory is used.

The format of the output can be controlled using the -f option. Supported formats are std and concise. The default is std. std format is:

 require "abc.pl";

$myvar = ...

$result = &myfunc($myparams);

concise format has fewer blank lines and uses 1 line per symbol.

A comma-separated list of symbol types to output can be specified using the -s option. Supported symbol types are:

•   sub - subroutines

•   var - variables

The default is to extract all symbols.

The -p option is used to extract only a subset of the symbols. If not supplied, the pattern is symbols beginning with a letter. If supplied without an option, the pattern defaults to all symbols. If perl libraries use the coding convention that symbols beginning with underscore are private, then -p_ can be used to extract the private symbols.

The -j option can be used to request SDF-style hypertext jumps be added for each symbol. The jump target is lib_sym where:

•   lib is the library name

•   sym is the symbol name.

LIMITATIONS AND FUTURE DIRECTIONS
The only language currently supported is Perl.

It would be useful to extract messages from the scripts too. This would require a new utility called sdfmsg say, which searched through the source (including libraries) for AppMsg and AppExit calls.

Internally, it may be better to implement formats via routines. This would give better control over output. e.g. it would be up to the routine to decide if it wanted to output the 'require' header.